local monarch = require "monarch.monarch"
local uz_state = require "uzelok.system.uzstate"

local M = {}

local function goto_issue(self, issue, button)
  -- monarch.hide(hash("splash"))
  monarch.show(hash("uzissues"), {sequential = true,  no_stack = true }, {issue_nr = issue})

  -- Init Navigation
  uz_state.state.issue = issue
  uz_state.state.chapter = 1
  uz_state.state.page = 1
end
--[[
original callback function
function()
	local position = gui.get_position(clone_prefab["cell_prefab"])
	grid_scroll:scroll_to(position)
end
]]

local function init_scroll_with_grid(self)
  local prefab = gui.get_node("cell_prefab")
  local cell_count = 2

  local grid_scroll = self.druid:new_scroll("view_point", "scroll_canvas")
  local grid = self.druid:new_grid("scroll_canvas", "cell_prefab", cell_count)

  for i = 1, cell_count do
    -- Referenz auf der Clone (Hash) mit Tabelle mit Cloned Nodes Index = NodeName
    local clone_prefab = gui.clone_tree(prefab)
    grid:add(clone_prefab["cell_prefab"])
    --gui.set_text(clone_prefab["cell_prefab_text"], "Выпуск " .. i)
    local button = self.druid:new_button(clone_prefab["cell_prefab_button"], goto_issue, i)
    button:set_click_zone(gui.get_node("view_point"))
  end

  gui.set_enabled(prefab, false)

  grid_scroll:set_size(grid:get_size())
  grid_scroll:set_points(grid:get_all_pos())

  --[[
	local scroll_slider = self.druid:new_slider("grid_scroll_pin", vmath.vector3(287, 0, 0), function(_, value)
		grid_scroll:scroll_to_percent(vmath.vector3(value, 0, 0), true)
	end)

	grid_scroll.on_scroll:subscribe(function(_, point)
		scroll_slider:set(grid_scroll:get_percent().x, true)
	end)
	]]
  -- save to further use in init_view_pos(self)
  self.druid_grid_scroll = grid_scroll
  self.druid_grid = grid
end

local function init_view_pos (self)
  --self.druid_grid:set_anchor(self.druid_grid:get_all_pos()[#self.druid_grid:get_all_pos()])
  --self.druid_grid_scroll:scroll_to(self.druid_grid:get_all_pos()[#self.druid_grid:get_all_pos()]) -- last pos
  self.druid_grid_scroll:scroll_to(self.druid_grid:get_all_pos()[1]) -- first pos
end

--local function init_uz_pos (self)
--	uz_state.init_state(issue)
--end


function M.setup_page(self)
  -- Init Scroll with grid
  init_scroll_with_grid(self)
  init_view_pos (self)
  --	init_uz_pos(self);
end


return M
