local navconst = require "uzelok.issues.is1.uznav.uznav_const"

local M = {}

local P = {}

function M.get_button_props(usnav_button)
  if P[usnav_button] then
    return P[usnav_button]
  else
    return nil
  end
end

P[navconst.BTN_FORWARDS] = {
  name = navconst.BTN_FORWARDS,
  init_state = navconst.STATE_ENABLED,
  init_design = 1,
  atlas = "uznav_buttuns_is1",
  textures = {
    bkg = {
      [1] = {
        default = "uznav_150_bkg",
        hover = "uznav_150_bkg_glow",
        pressed = "uznav_150_bkg_glow",
        disabled = "empty",
      },
    },
    glyph = {
      [1] = {
        default = "uznav_150_forwards",
        hover = "uznav_150_forwards_glow",
        pressed = "uznav_150_forwards_glow",
        disabled = "empty",
      },
    },
  },
  messages_to_subscribe = navconst.IN_MESSAGES,
  message_to_send = {
    message_id = navconst.MSG_FORWARDS,
    message = "get_subpage_level", -- function name to resolve , param (self)
  },
}

P[navconst.BTN_BACKWARDS] = {
  name = navconst.BTN_BACKWARDS,
  init_state = navconst.STATE_ENABLED,
  init_design = 1,
  atlas = "uznav_buttuns_is1",
  textures = {
    bkg = {
      [1] = {
        default = "uznav_150_bkg",
        hover = "uznav_150_bkg_glow",
        pressed = "uznav_150_bkg_glow",
        disabled = "empty",
      },
    },
    glyph = {
      [1] = {
        default = "uznav_150_backwards",
        hover = "uznav_150_backwards_glow",
        pressed = "uznav_150_backwards_glow",
        disabled = "empty",
      },
    },
  },
  messages_to_subscribe = navconst.IN_MESSAGES,
  message_to_send = {
    message_id = navconst.MSG_BACKWARDS,
    message = "get_subpage_level", -- function name to resolve , param (self)
  },
}

P[navconst.BTN_MENU] = {
  name = navconst.BTN_MENU,
  init_state = navconst.STATE_ENABLED,
  init_design = 1,
  atlas = "uznav_buttuns_is1",
  textures = {
    bkg = {
      [1] = {
        default = "uznav_120_bkg",
        hover = "uznav_120_bkg_glow",
        pressed = "uznav_120_bkg_glow",
        disabled = "empty",
      },
    },
    glyph = {
      [1] = {
        default = "uznav_120_menu",
        hover = "uznav_120_menu_glow",
        pressed = "uznav_120_menu_glow",
        disabled = "empty",
      },
    },
  },
  messages_to_subscribe = navconst.IN_MESSAGES,
  message_to_send = {
    message_id = navconst.MSG_MENU,
    message = "no_message", -- function name to resolve , param (self)
  },
}

P[navconst.BTN_SOLVE] = {
  name = navconst.BTN_SOLVE,
  init_state = navconst.STATE_ENABLED,
  init_design = 1,
  atlas = "uznav_buttuns_is1",
  textures = {
    bkg = {
      [1] = {
        default = "uznav_120_bkg",
        hover = "uznav_120_bkg_glow",
        pressed = "uznav_120_bkg_glow",
        disabled = "empty",
      },
    },
    glyph = {
      [1] = {
        default = "uznav_120_solve",
        hover = "uznav_120_solve_glow",
        pressed = "uznav_120_solve_glow",
        disabled = "empty",
      },
    },
  },
  messages_to_subscribe = navconst.IN_MESSAGES,
  message_to_send = {
    message_id = navconst.MSG_SOLVE,
    message = "no_message", -- function name to resolve , param (self)
  },
}

P[navconst.BTN_RELOAD] = {
  name = navconst.BTN_RELOAD,
  init_state = navconst.STATE_ENABLED,
  init_design = 1,
  atlas = "uznav_buttuns_is1",
  textures = {
    bkg = {
      [1] = {
        default = "uznav_120_bkg",
        hover = "uznav_120_bkg_glow",
        pressed = "uznav_120_bkg_glow",
        disabled = "empty",
      },
    },
    glyph = {
      [1] = {
        default = "uznav_120_reload",
        hover = "uznav_120_reload_glow",
        pressed = "uznav_120_reload_glow",
        disabled = "empty",
      },
    },
  },
  messages_to_subscribe = navconst.IN_MESSAGES,
  message_to_send = {
    message_id = navconst.MSG_RELOAD,
    message = "no_message", -- function name to resolve , param (self)
  },
}

P[navconst.BTN_WORD_TO_PARENTS] = {
  name = navconst.BTN_WORD_TO_PARENTS,
  init_state = navconst.STATE_ENABLED,
  init_design = 1,
  atlas = "uznav_buttuns_is1",
  textures = {
    bkg = {
      [1] = {
        default = "uznav_120_bkg",
        hover = "uznav_120_bkg_glow",
        pressed = "uznav_120_bkg_glow",
        disabled = "empty",
      },
    },
    glyph = {
      [1] = {
        default = "uznav_120_wtp",
        hover = "uznav_120_wtp_glow",
        pressed = "uznav_120_wtp_glow",
        disabled = "empty",
      },
    },
  },
  messages_to_subscribe = navconst.IN_MESSAGES,
  message_to_send = {
    message_id = navconst.MSG_SOLVE,
    message = "no_message", -- function name to resolve , param (self)
  },
}

P[navconst.BTN_SOUND_PLAY] = {
  name = navconst.BTN_SOUND_PLAY,
  init_state = navconst.STATE_ENABLED,
  init_design = 1,
  atlas = "uznav_buttuns_is1",
  textures = {
    bkg = {
      [1] = {
        default = "uznav_120_bkg",
        hover = "uznav_120_bkg_glow",
        pressed = "uznav_120_bkg_glow",
        disabled = "empty",
      },
    },
    glyph = {
      [1] = {
        default = "uznav_120_play",
        hover = "uznav_120_play_glow",
        pressed = "uznav_120_play_glow",
        disabled = "empty",
      },
    },
  },
  messages_to_subscribe = navconst.IN_MESSAGES,
  message_to_send = {
    message_id = navconst.MSG_SOUND_PLAY,
    message = "no_message", -- function name to resolve , param (self)
  },
}

P[navconst.BTN_SOUND_PAUSE] = {
  name = navconst.BTN_SOUND_PAUSE,
  init_state = navconst.STATE_ENABLED,
  init_design = 1,
  atlas = "uznav_buttuns_is1",
  textures = {
    bkg = {
      [1] = {
        default = "uznav_120_bkg",
        hover = "uznav_120_bkg_glow",
        pressed = "uznav_120_bkg_glow",
        disabled = "empty",
      },
    },
    glyph = {
      [1] = {
        default = "uznav_120_pause",
        hover = "uznav_120_pause_glow",
        pressed = "uznav_120_pause_glow",
        disabled = "empty",
      },
    },
  },
  messages_to_subscribe = navconst.IN_MESSAGES,
  message_to_send = {
    message_id = navconst.MSG_SOUND_PLAY,
    message = "no_message", -- function name to resolve , param (self)
  },
}

return M
