local navconst = require "uzelok.issues.is1.uznav.uznav_const"

local M = {}

local P = {}

local function get_subpage_level(self)
  return {subpage_level = self.navbtn.subpage_level}
end

local function no_message(self)
  return {}
end

function M.get_button_props(usnav_button)
  if P[usnav_button] then
    return P[usnav_button]
  else
    return nil
  end
end

P[navconst.BTN_FORWARDS] = {
  name = navconst.BTN_FORWARDS,
  init_state = navconst.STATE_ENABLED,
  init_design = 1,
  atlas = "uznav_buttuns",
  textures = {
    bkg = {
      [1] = {
        default = "bkg",
        hover = "bkg_glow",
        pressed = "bkg_glow",
        disabled = "empty",
      },
    },
    glyph = {
      [1] = {
        default = "glyph",
        hover = "glyph_glow",
        pressed = "glyph_glow",
        disabled = "empty",
      },
    },
  },
  messages_to_subscribe = navconst.IN_MESSAGES,
  message_to_send = {
    message_id = navconst.MSG_FORWARDS,
    message = "get_subpage_level", --param (self)
  },
}

P[navconst.BTN_BACKWARDS] = {
  name = navconst.BTN_BACKWARDS,
  init_state = navconst.STATE_ENABLED,
  init_design = 1,
  atlas = "uznav_buttuns",
  textures = {
    bkg = {
      [1] = {
        default = "bkg",
        hover = "bkg_glow",
        pressed = "bkg_glow",
        disabled = "empty",
      },
    },
    glyph = {
      [1] = {
        default = "glyph",
        hover = "glyph_glow",
        pressed = "glyph_glow",
        disabled = "empty",
      },
    },
  },
  messages_to_subscribe = navconst.IN_MESSAGES,
  message_to_send = {
    message_id = navconst.MSG_BACKWARDS,
    message = "get_subpage_level", --(self)
  },
}

P[navconst.BTN_MENU] = {
  name = navconst.BTN_MENU,
  init_state = navconst.STATE_ENABLED,
  init_design = 1,
  atlas = "uznav_buttuns",
  textures = {
    bkg = {
      [1] = {
        default = "bkg",
        hover = "bkg_glow",
        pressed = "bkg_glow",
        disabled = "empty",
      },
    },
    glyph = {
      [1] = {
        default = "glyph",
        hover = "glyph_glow",
        pressed = "glyph_glow",
        disabled = "empty",
      },
    },
  },
  messages_to_subscribe = navconst.IN_MESSAGES,
  message_to_send = {
    message_id = navconst.MSG_MENU,
    message = "no_message", --(self)
  },
}

P[navconst.BTN_SOLVE] = {
  name = navconst.BTN_SOLVE,
  init_state = navconst.STATE_ENABLED,
  init_design = 1,
  atlas = "uznav_buttuns",
  textures = {
    bkg = {
      [1] = {
        default = "bkg",
        hover = "bkg_glow",
        pressed = "bkg_glow",
        disabled = "empty",
      },
    },
    glyph = {
      [1] = {
        default = "glyph",
        hover = "glyph_glow",
        pressed = "glyph_glow",
        disabled = "empty",
      },
    },
  },
  messages_to_subscribe = navconst.IN_MESSAGES,
  message_to_send = {
    message_id = navconst.MSG_SOLVE,
    message = "no_message", --(self)
  },
}

P[navconst.BTN_RELOAD] = {
  name = navconst.BTN_RELOAD,
  init_state = navconst.STATE_ENABLED,
  init_design = 1,
  atlas = "uznav_buttuns",
  textures = {
    bkg = {
      [1] = {
        default = "bkg",
        hover = "bkg_glow",
        pressed = "bkg_glow",
        disabled = "empty",
      },
    },
    glyph = {
      [1] = {
        default = "glyph",
        hover = "glyph_glow",
        pressed = "glyph_glow",
        disabled = "empty",
      },
    },
  },
  messages_to_subscribe = navconst.IN_MESSAGES,
  message_to_send = {
    message_id = navconst.MSG_RELOAD,
    message = "no_message", --(self)
  },
}

P[navconst.BTN_WORD_TO_PARENTS] = {
  name = navconst.BTN_WORD_TO_PARENTS,
  init_state = navconst.STATE_ENABLED,
  init_design = 1,
  atlas = "uznav_buttuns",
  textures = {
    bkg = {
      [1] = {
        default = "bkg",
        hover = "bkg_glow",
        pressed = "bkg_glow",
        disabled = "empty",
      },
    },
    glyph = {
      [1] = {
        default = "glyph",
        hover = "glyph_glow",
        pressed = "glyph_glow",
        disabled = "empty",
      },
    },
  },
  messages_to_subscribe = navconst.IN_MESSAGES,
  message_to_send = {
    message_id = navconst.MSG_SOLVE,
    message = "no_message", --(self)
  },
}

P[navconst.BTN_SOUND_PLAY] = {
  name = navconst.BTN_SOUND_PLAY,
  init_state = navconst.STATE_ENABLED,
  init_design = 1,
  atlas = "uznav_buttuns",
  textures = {
    bkg = {
      [1] = {
        default = "bkg",
        hover = "bkg_glow",
        pressed = "bkg_glow",
        disabled = "empty",
      },
    },
    glyph = {
      [1] = {
        default = "glyph",
        hover = "glyph_glow",
        pressed = "glyph_glow",
        disabled = "empty",
      },
    },
  },
  messages_to_subscribe = navconst.IN_MESSAGES,
  message_to_send = {
    message_id = navconst.MSG_SOUND_PLAY,
    message = "no_message", --(self)
  },
}

P[navconst.BTN_SOUND_PAUSE] = {
  name = navconst.BTN_SOUND_PAUSE,
  init_state = navconst.STATE_ENABLED,
  init_design = 1,
  atlas = "uznav_buttuns",
  textures = {
    bkg = {
      [1] = {
        default = "bkg",
        hover = "bkg_glow",
        pressed = "bkg_glow",
        disabled = "empty",
      },
    },
    glyph = {
      [1] = {
        default = "glyph",
        hover = "glyph_glow",
        pressed = "glyph_glow",
        disabled = "empty",
      },
    },
  },
  messages_to_subscribe = navconst.IN_MESSAGES,
  message_to_send = {
    message_id = navconst.MSG_SOUND_PLAY,
    message = "no_message", --(self)
  },
}

return M
