
local M = {}
M.BTN_MENU = "btn_menu"
M.BTN_SOLVE = "btn_solve"
M.BTN_RELOAD = "btn_reload"
M.BTN_FORWARDS = "btn_forwards"
M.BTN_BACKWARDS = "btn_backwards"
--M.BTN_GOTO_PAGE = "btn_goto_page"
--M.BTN_SOUND_MUTE = "btn_sound_mute" -- mute/restore
M.BTN_SOUND_PLAY = "btn_sound_play" --play/stop
M.BTN_SOUND_PAUSE = "btn_sound_pause" --pause/release
--M.BTN_VIDEO_PLAY = "btn_video_play" --play/stop
--M.BTN_VIDEO_PAUSE = "btn_video_pause" --pause/release
--M.BTN_DONATE = "btn_donate"
M.BTN_WORD_TO_PARENTS = "btn_word_to_parents"

M.BUTTONS = {
  M.BTN_MENU,
  M.BTN_SOLVE,
  M.BTN_RELOAD,
  M.BTN_FORWARDS,
  M.BTN_BACKWARDS,
  -- M.BTN_GOTO_PAGE,
  -- M.BTN_SOUND_MUTE,
  M.BTN_SOUND_PLAY,
  M.BTN_SOUND_PAUSE,
  --M.BTN_VIDEO_PLAY,
  --M.BTN_VIDEO_PAUSE,
  --M.BTN_DONATE,
  M.BTN_WORD_TO_PARENTS,
}

M.MSG_MENU = hash("uznav_msg_menu_pressed")
M.MSG_SOLVE = hash("uznav_msg_solve_pressed")
M.MSG_RELOAD = hash("uznav_msg_reload_pressed")
M.MSG_FORWARDS = hash("uznav_msg_forwards_pressed") --{subpage_level = 0}
M.MSG_BACKWARDS = hash("uznav_msg_backwards_pressed") -- {subpage_level = 0 }
--M.MSG_GOTO_PAGE = hash("uznav_msg_goto_page_pressed") -- {page_no = 1, [subpage_no = 1]}
M.MSG_SOUND_PLAY = hash("uznav_msg_sound_play_pressed") -- {action = "play"}  play/stop
M.MSG_SOUND_PAUSE = hash("uznav_msg_sound_pause_pressed") -- {action = "pause"}  pause/continue
--M.MSG_SOUND_MUTE = hash("uznav_msg_sound_mute_pressed") -- {action = "mute"}  mute/restore
--M.MSG_VIDEO_PLAY = hash("uznav_msg_video_play_pressed") -- {action = "play"}  play/stop
--M.MSG_VIDEO_PAUSE = hash("uznav_msg_video_pause_pressed") -- {action = "pause"}  pause/release
--M.MSG_DONATE = hash("uznav_msg_donate_pressed")
M.MSG_WORD_TO_PARENTS = hash("uznav_msg_word_to_parents_pressed")

M.OUT_MESSAGES = {
  M.MSG_MENU,
  M.MSG_SOLVE,
  M.MSG_RELOAD,
  M.MSG_FORWARDS,
  M.MSG_BACKWARDS,
  --M.MSG_GOTO_PAGE,
  M.MSG_SOUND_PLAY,
  M.MSG_SOUND_PAUSE,
  --M.MSG_SOUND_MUTE,
  --M.MSG_VIDEO_PLAY,
  --M.MSG_VIDEO_PAUSE,
  M.MSG_WORD_TO_PARENTS,
}

M.ACTION_PLAY = "play"
M.ACTION_STOP = "stop"
M.ACTION_PAUSE = "pause"
M.ACTION_CONTINUE = "continue"
M.ACTION_MUTE = "mute"
M.ACTION_RESTORE = "restore"

M.ACTIONS = {
  M.ACTION_PLAY,
  M.ACTION_STOP,
  M.ACTION_PAUSE,
  M.ACTION_MUTE,
  M.ACTION_RESTORE,
}

M.MSG_SET_BUTTON_STATE = hash("uznav_msg_set_button_state") -- {button = M.BTN_MENU , to_state = "enabled"} enabled/disabled
M.MSG_SET_SUBPAGE_LEVEL = hash("uznav_msg_set_subpage_level") -- {button = navconst.BTN_FORWARDS, subpage_level = 0 }
M.MSG_SET_NAV_STATE = hash("uznav_msg_set_nav_state") -- {state = "enabled"} enabled/disabled
M.MSG_PRESS_BUTTON = hash("uznav_msg_press_button") --{button = M.BTN_MENU}
M.MSG_SET_BUTTON_DESIGN = hash("uznav_msg_set_button_design") -- {button = navconst.BTN_FORWARDS, design_no = 0 }
M.MSG_INIT_BUTTON = hash("uznav_msg_init_button") -- {button = navconst.BTN_FORWARDS, btn_props = uznav_btnprops.get_button_props[navconst.BTN_FORWARDS] }

M.IN_MESSAGES = {
  M.MSG_SET_BUTTON_STATE,
  M.MSG_SET_SUBPAGE_LEVEL,
  M.MSG_SET_NAV_STATE,
  M.MSG_PRESS_BUTTON,
  M.MSG_SET_BUTTON_DESIGN,
  M.MSG_INIT_BUTTON,
}

M.STATE_ENABLED = "enabled"
M.STATE_DISABLED = "disabled"

M.STATES = {
  M.STATE_ENABLED,
  M.STATE_DISABLED,
}

return M
